---
title: DataTransferItemList.DataTransferItem()
slug: Web/API/DataTransferItemList/DataTransferItem
tags:
  - API
  - DataTransferItemList
  - Getter
  - HTML DOM
  - HTML Drag and Drop API
  - Method
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>The <strong><code>DataTransferItem()</code></strong> getter method implements support for accessing items in the {{domxref("DataTransferItemList")}} using array-style syntax (that is <code><em>DataTransferItem</em>[<em>index</em>]</code>).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>dataItem</em> = <em>DataTransferItem</em>[<em>index</em>];
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>index</code></dt>
 <dd>The zero-based index of the item in the drag data list to return.</dd>
</dl>

<h3 id="Return_Value">Return value</h3>

<p>The {{domxref("DataTransferItem")}} object at the specified index in the item list. If the index is less than zero or greater than or equal to the number of items in the list (as indicated by the list's {{domxref("DataTransferItemList.length","length")}} property, <code>undefined</code> is returned. The returned value is never <code>null</code>.</p>

<h2 id="Example_Drag_and_Drop">Example</h2>

<p>This example shows how to use drag and drop.</p>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">function dragstart_handler(ev) {
  console.log("dragStart");
  // Add this element's id to the drag payload so the drop handler will
  // know which element to add to its tree
  var dataList = ev.dataTransfer.items;
  dataList.add(ev.target.id, "text/plain");
  // Add some other items to the drag payload
  dataList.add("&lt;p&gt;... paragraph ...&lt;/p&gt;", "text/html");
  dataList.add("http://www.example.org","text/uri-list");
}

function drop_handler(ev) {
  console.log("Drop");
  ev.preventDefault();
  var data = ev.dataTransfer.items;
  // Loop through the dropped items and log their data
  for (var i = 0; i &lt; data.length; i++) {
    if ((data[i].kind == 'string') &amp;&amp; (data[i].type.match('^text/plain'))) {
      // This item is the target node
      data[i].getAsString(function (s){
        ev.target.appendChild(document.getElementById(s));
      });
    } else if ((data[i].kind == 'string') &amp;&amp; (data[i].type.match('^text/html'))) {
      // Drag data item is HTML
      data[i].getAsString(function (s){
        console.log("... Drop: HTML = " + s);
      });
    } else if ((data[i].kind == 'string') &amp;&amp; (data[i].type.match('^text/uri-list'))) {
      // Drag data item is URI
      data[i].getAsString(function (s){
        console.log("... Drop: URI = " + s);
      });
    }
  }
}

function dragover_handler(ev) {
  console.log("dragOver");
  ev.preventDefault();
  // Set the dropEffect to move
  ev.dataTransfer.dropEffect = "move"
}

function dragend_handler(ev) {
  console.log("dragEnd");
  var dataList = ev.dataTransfer.items;
  // Clear any remaining drag data
  dataList.clear();
}

</pre>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;
  &lt;p id="source" ondragstart="dragstart_handler(event);" ondragend="dragend_handler(event);" draggable="true"&gt;
     Select this element, drag it to the Drop Zone and then release the selection to move the element.&lt;/p&gt;
&lt;/div&gt;
&lt;div id="target" ondrop="drop_handler(event);" ondragover="dragover_handler(event);"&gt;Drop Zone&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">div {
  margin: 0em;
  padding: 2em;
}

#source {
  color: blue;
  border: 1px solid black;
}

#target {
  border: 1px solid black;
}
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example_Drag_and_Drop', '35%', '250px')}}</p>

<p>{{LiveSampleLink('Example_Drag_and_Drop', 'Drag and Drop demo link')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#the-datatransferitemlist-interface','DataTransferItem getter')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransferItemList.DataTransferItem")}}</p>
